// ============================================================================

// EnvCell.h: interface for the EnvCell class.

//

// ============================================================================



#ifndef __ENVCELL_H__

#define __ENVCELL_H__



#include "Utilities.h"



#include <scew.h>



class EnvCell

{

public:

  int intCount;

  BYTE * values;



  // coordinates

  int intPos;

  double x, y;



public:



  EnvCell();

  EnvCell(int ct, BYTE * val);

  EnvCell(int ct, BYTE * val, int pos, double x, double y);

  virtual ~EnvCell();



  void setSize(int newSize);

  int size();

  void setValues(BYTE * newValues);

  BYTE * getValues();



  char * toXML();

  static EnvCell * fromXML(char * strXML);



  bool operator==(EnvCell oCell);

  bool operator!=(EnvCell oCell);



  static EnvCell * fromXML(scew_element const * pNode);

};



// ============================================================================

#endif // __ENVCELL_H__



