/**
 *    '$RCSfile: GarpAlgorithm.java,v $'
 *
 *     '$Author: berkley $'
 *       '$Date: 2004/01/08 00:48:15 $'
 *   '$Revision: 1.8 $'
 *
 *  For Details: http://kepler.ecoinformatics.org
 *
 * Copyright (c) 2003 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY
 * OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

package org.ecoinformatics.seek.garp;

import ptolemy.data.RecordToken;
import ptolemy.data.StringToken;
import ptolemy.data.IntToken;
import ptolemy.data.DoubleToken;
import ptolemy.data.LongToken;
import ptolemy.data.Token;
import ptolemy.actor.gui.EditorPaneFactory;
import ptolemy.data.type.RecordType;
import ptolemy.data.expr.Parameter;
import ptolemy.data.type.BaseType;
import ptolemy.data.type.Type;
import ptolemy.kernel.CompositeEntity;
import ptolemy.kernel.util.*;
import ptolemy.actor.TypedAtomicActor;
import ptolemy.actor.TypedIOPort;
import org.ecoinformatics.seek.workflow.gui.NewActorFrame;
import org.ecoinformatics.seek.garp.GarpJniGlue;
import javax.swing.JOptionPane;

/*<p></p>*/

public class GarpAlgorithm extends TypedAtomicActor
{
  //input ports
  public TypedIOPort cellSetFilename = new TypedIOPort(this, "cellSetFileName",
    true, false);
  public TypedIOPort ruleSetFilename = new TypedIOPort(this, "ruleSetFilename",
    true, false);
  //output ports
  public TypedIOPort ruleSetFilenameOutput = new TypedIOPort(this,
    "ruleSetFilenameOutput", false, true);

  /**
   * GarpAlgorithm Actor
   */
  public GarpAlgorithm(CompositeEntity container, String name)
    throws NameDuplicationException, IllegalActionException
  {
    super(container, name);
    cellSetFilename.setTypeEquals(BaseType.STRING);
    ruleSetFilename.setTypeEquals(BaseType.STRING);
    ruleSetFilenameOutput.setTypeEquals(BaseType.STRING);
  }

  /**
   *
   */
  public void initialize()
    throws IllegalActionException
  {
  }

  /**
   *
   */
  public boolean prefire()
    throws IllegalActionException
  {
    return super.prefire();
  }

  /**
   *
   */
  public void fire()
    throws IllegalActionException
  {
    System.out.println("firing GarpAlgorithm");
    super.fire();
    //get the cellset filename from the port
    StringToken cellsetfnToken = (StringToken)cellSetFilename.get(0);
    String cellSetFileNameStr = cellsetfnToken.stringValue();
    //get the ruleset filename from the port
    StringToken rulesetfnToken = (StringToken)ruleSetFilename.get(0);
    String ruleSetFileNameStr = rulesetfnToken.stringValue();
    //make the jni call to the c++ code
    System.out.println("Running GarpAlgorithm JNI code");
    new GarpJniGlue().RunGarpAlgorithm(ruleSetFileNameStr, cellSetFileNameStr);

    ruleSetFilenameOutput.broadcast(new StringToken(ruleSetFileNameStr));

    System.out.println("Running GarpAlgorithm JNI code");
  }
}
