
package org.geon.test;

import java.util.*;
import java.awt.geom.Point2D;

import java.io.*;
//import java.net.*;
//import javax.xml.parsers.*;
//import org.w3c.dom.*;
//import java.net.HttpURLConnection;
//import java.net.URI;
import org.apache.xpath.XPathAPI;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.w3c.dom.Document;


public class RockSample1 {

    private static Set minerals = new TreeSet();

    static {

	minerals.add("quartz");
	minerals.add("k-feldspar");
	minerals.add("microcline");
	minerals.add("plagioclase");
	minerals.add("biotite");
	minerals.add("muscovite");
	minerals.add("amphibole");
	minerals.add("olivine");
	minerals.add("epidote");
	minerals.add("allanite");
	minerals.add("garnet");
	minerals.add("clinopyroxene");
	minerals.add("orthopyroxene");
	minerals.add("ilmenite");
	minerals.add("magnetite");
	minerals.add("opaques");
	minerals.add("zircon");
	minerals.add("apatite");
	minerals.add("carbonate");
	minerals.add("hornblende");
	minerals.add("magnesio-hornblende");
	minerals.add("paragasitic-hornblende");
    }

    
    /** The path to the diagram files */
    private String diagramsPath = "";
    
    /** The currently processed diagram */
    private String currentDiagramPath = "";
    private String id;
    
    /** transitions file name */
    private String transitionsFile = "";
    private Map data = new TreeMap();

    // set current diagram path.
    public void setCurrentDiagramPath(String path) {
      currentDiagramPath = path;
    }

    public String getCurrentDiagramPath() {
      return currentDiagramPath;
    }

    // set current diagram path.
    public void setDiagramsPath(String path) {
      diagramsPath = path;
    }

    public String getDiagramsPath() {
      return diagramsPath;
    }

    // add a mineral into this record
    public void add(String att, String val) {
	if (att.equals("ssID")) {
	    id = val;
            data.put(att, val);
	} else if (minerals.contains(att)) {
	    if (val.equals("") || val.equals("tr")) {
		data.put(att, new Float(0));
	    } else {
		data.put(att, new Float(Float.parseFloat(val)));
	    }
	}
    }

    public float get(String att) {
        if (att.equals("ssID")) {
          return Float.parseFloat(id);
        } else if (!minerals.contains(att)) {
          return 0;
        } else {
          return ( (Float) data.get(att)).floatValue();
        }
    }

    private Map mineralAbbrev = new HashMap();

    public void createAbbrevTable(File abbrevFile) {
      try {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(false);
        DocumentBuilder builder = factory.newDocumentBuilder();
        InputStream is = new FileInputStream(abbrevFile);
        Document doc = builder.parse(is);

		Map minAbbrev = this.getAbbrevTable();

        String xPath = "//abb";
        Node contextNode = doc.getDocumentElement();
        NodeList _abbrevs = XPathAPI.selectNodeList(contextNode, xPath);

        for (int i = 0; i < _abbrevs.getLength(); i++) {
          Node abb = _abbrevs.item(i);
          String _abb = ( (Element) abb).getAttribute("name");
          ArrayList minList = new ArrayList();
          NodeList _minerals = XPathAPI.selectNodeList(abb, "min");
          for (int j = 0; j < _minerals.getLength(); j++) {
            String min = (_minerals.item(j)).getFirstChild().getNodeValue();
            System.out.println("    " + min);
            minList.add(min);
          }
		  System.out.println(_abb);
		  minAbbrev.put(_abb, minList);
        }
        is.close();
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }

    public Map getAbbrevTable() {
      return mineralAbbrev;
    }

    public void setAbbrevTable(Map abbrevs) {
      mineralAbbrev = abbrevs;
    }

    // add a mineral abbreviation into this record
    public void addAbbrev(String abb, ArrayList minerals) {
        mineralAbbrev.put(abb,minerals);
    }

    public ArrayList getAbbrev(String abb) {
        return (ArrayList) mineralAbbrev.get(abb);
    }

    public String getTransFile() {
      return transitionsFile;
    }

    public void setTransFile(String fileName) {
      transitionsFile = fileName;
    }

    private static Map Diagrams = new HashMap();

    public void createDiagramIdMap(File MappingFile) {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setValidating(false);
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputStream is = new FileInputStream(MappingFile);
            Document doc = builder.parse(is);
            
            NodeList pathNode = doc.getElementsByTagName("path");
            NodeList diagrams = doc.getElementsByTagName("diagram");
            
            String path = pathNode.item(0).getFirstChild().getNodeValue();
            //set path to the diagrams
            setDiagramsPath(path);
            
            // push the diagram-id mapping into the Diagrams hash map. 
            for (int i = 0; i < diagrams.getLength(); i++) {
            	String diagramId = ( (Element) diagrams.item(i)).getAttribute("id");
            	String diagramName = ( (Element) diagrams.item(i)).getAttribute("name");
            	
            	Diagrams.put(diagramId,diagramName);
            }            	
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

/*    public void createDiagramsTable() { //FIX ME! TODO!!
      int i = 0;
    }
*/
    public String getDiagram(String id) {
      return (String) Diagrams.get(id);
    }

    private float getQ() {
	return ((Float)data.get("quartz")).floatValue();
    }

    private float getA() {
        return
	    ((Float)data.get("k-feldspar")).floatValue() +
	    ((Float)data.get("microcline")).floatValue();
    }

    private float getP() {

        return ((Float)data.get("plagioclase")).floatValue();
    }

    private float getM() {
        return
	    ((Float)data.get("biotite")).floatValue() +
	    ((Float)data.get("muscovite")).floatValue() +
	    ((Float)data.get("amphibole")).floatValue() +
	    ((Float)data.get("olivine")).floatValue() +
	    ((Float)data.get("epidote")).floatValue() +
	    ((Float)data.get("allanite")).floatValue() +
	    ((Float)data.get("garnet")).floatValue() +
	    ((Float)data.get("clinopyroxene")).floatValue() +
	    ((Float)data.get("orthopyroxene")).floatValue() +
	    ((Float)data.get("ilmenite")).floatValue() +
	    ((Float)data.get("magnetite")).floatValue() +
	    ((Float)data.get("opaques")).floatValue() +
	    ((Float)data.get("zircon")).floatValue() +
	    ((Float)data.get("apatite")).floatValue() +
	    ((Float)data.get("carbonate")).floatValue();
    }


    public boolean isFelsic() {

	float p = getP();
	float a = getA();
	float q = getQ();
	float m = getM();

	if ( m / (p + a + q + m) < 0.9 ) {
	    return true;
	} else {
	    return false;
	}
    }


    public boolean isUltramafic() {
	return ! isFelsic();
    }


    public String getId() {
	return id;
    }

//TODO: add validate function!

    public Point2D.Double getPointForGabbroOlivine(
      double leftPadding, double topPadding, double diagramWidth, double diagramHeight,
      String topVertex, String leftVertex, String rightVertex, String bottomVertex) {

	System.out.println("the diagram path is " + this.getCurrentDiagramPath());
// FIX ME: how to handle bottomVertex.
      Map mineralAbbrev = this.getAbbrevTable();

	      double X = 0,Y = 0;
	      double top = getCoordinateSum(topVertex);
		  double right = getCoordinateSum(rightVertex);
		  double left = getCoordinateSum(leftVertex);

        double sum = top + right + left;

        System.out.println("sum = " + sum);

        X = right / sum;
        Y = top / sum;

        System.out.println("X = " + X + " , Y = " + Y);
//        alakaliValue = alakaliValue / sum;
 //      if (layer == 2) {
//        System.out.println("HERE!!!");
/*	double plagValue = ((Float)data.get("plagioclase")).floatValue();
	double olValue =  ((Float)data.get("olivine")).floatValue();
	double cpxValue = ((Float)data.get("clinopyroxene")).floatValue();
	double opxValue = ((Float)data.get("orthopyroxene")).floatValue();

        System.out.println("diagramWidth: " + diagramWidth);
        System.out.println("plagValue: " + plagValue);
        System.out.println("olValue: " + olValue);
        System.out.println("cpxValue: " + cpxValue);
        System.out.println("opxValue: " + opxValue);
	double pxValue = cpxValue + opxValue;
	double sum = plagValue + olValue + pxValue;

        System.out.println("plageValue = " + plagValue);
        System.out.println("olValue = " + olValue);
        System.out.println("cpxValue == " + cpxValue);
        System.out.println("opxValue == " + opxValue);
        System.out.println("pxValue = " + pxValue);
        System.out.println("sum = " + sum);

//        System.out.println("sum: " + sum);

	Y = plagValue / sum;
	X = olValue / sum;

        System.out.println("X: " + X + "  ,  Y:" + Y);

//	pxValue = pxValue /sum; */
 //     }
	// calculate x and y coordinates
	double x1 = leftPadding + ( X * diagramWidth);
	double y1 = topPadding + diagramHeight;

	double y0 = topPadding + ((1 - Y) * diagramHeight);
	double x0 = x1 + (y1 - y0)/(Math.tan(Math.PI/6)); //divide by tan(30) instead of sin(30)?

        System.out.println("x1 = " + x1 + " , y1 = " + y1 + " , x0 = " + x0 + " , y0 = " + y0);

	return new Point2D.Double(x0, y0);

    }

    public double getCoordinateSum(String vertex) {
    	System.out.println("vertex name is " + vertex);
    	double sum = 0;
    	ArrayList topMinerals = (ArrayList)mineralAbbrev.get(vertex);
    	if (topMinerals == null)
    		return -1;
    	//TODO: TAKE CARE OF MINERALS THAT DO NOT APPEAR IN THE ABBREV TABLE!!!
    	for (int i=0; i<topMinerals.size(); i++) {
			String mineral = (String)topMinerals.get(i);
			double minValue = ((Float)data.get(mineral)).floatValue();
			System.out.println(mineral + " :: " + minValue);
			sum += minValue;
		}
		return sum;
    }
}

