/**
 *    '$RCSfile: DSTableFieldDef.java,v $'
 *
 *     '$Author: tao $'
 *       '$Date: 2004/08/18 21:54:54 $'
 *   '$Revision: 1.1 $'
 *
 *  For Details: http://kepler.ecoinformatics.org
 *
 * Copyright (c) 2003 The Regents of the University of California.
 * All rights reserved.
 * 
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY
 * OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */
package org.ecoinformatics.seek.datasource;

/**
 * Simple Implementation of DSTableKeyIFace/DSTableFieldIFace interface
 * This class is derived from DataItemDescription
 */
public class DSTableFieldDef extends DataItemDescription implements DSTableKeyIFace
{
  protected int          mKeyType = DSTableKeyIFace.UNDEFINEDKEY;
  protected DSTableIFace mTable   = null;
  
  /**
   * Construct a DSTableFieldDef.
   * @param aId the id of the field
   * @param aName the name of the field
   * @param aDataType the datatype of the field
   */
  public DSTableFieldDef(String aId, String aName, String aDataType)
  {
    super(aId, aName, aDataType, null);
  }
 
  /**
   * Construct a DSTableFieldDef.
   * @param aId the id of the field
   * @param aName the name of the field
   * @param aDataType the datatype of the field
   * @param aKeyType the datatype of the field
   */
  public DSTableFieldDef(String aId, String aName, String aDataType, int aKeyType)
  {
    super(aId, aName, aDataType, null);
    mKeyType = aKeyType;
  }
  
  /**
   * Sets the Parent DSTableDef object
   * @param aTable DSTableDef object
   */
  public void setTable(DSTableIFace aTable)
  {
    mTable = aTable;
  }

  /**
   * Returns the table for the field
   * @return DSTableDef Object
   */
  public DSTableIFace getTable()
  {
    return mTable;
  }
  
  /**
   * @return Returns the mKeyType.
   */
  public int getKeyType()
  {
    return mKeyType;
  }
  
}
