/**
 *  Copyright: 2000 Regents of the University of California and the
 *             National Center for Ecological Analysis and Synthesis
 *
 * ********This class was auto-generated by the SEEK AMS engine.********
 * This software is governed by the following license:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.geon.test;
//tokens
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import ptolemy.data.DoubleToken;
import ptolemy.data.IntToken;
import ptolemy.data.LongToken;
import ptolemy.data.ObjectToken;
import ptolemy.data.RecordToken;
import ptolemy.data.StringToken;
import ptolemy.data.Token;
//
import ptolemy.data.type.RecordType;
import ptolemy.data.expr.Parameter;
import ptolemy.data.type.BaseType;
import ptolemy.data.type.Type;
import ptolemy.kernel.CompositeEntity;
import ptolemy.kernel.util.*;
import ptolemy.actor.TypedAtomicActor;
import ptolemy.actor.TypedIOPort;
import javax.swing.JOptionPane;

// xml processing
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/*<p></p>*/

public class NextDiagram1 extends TypedAtomicActor
{
  //input ports
  public TypedIOPort rowInfo = new TypedIOPort(this, "rowInfo", true, false);
  public TypedIOPort transitionTable = new TypedIOPort(this, "transitionTable", true, false);
  public TypedIOPort region = new TypedIOPort(this, "region", true, false);
  //output ports
  public TypedIOPort rockName = new TypedIOPort(this, "rockName", false, true);
  public TypedIOPort nextDiagram = new TypedIOPort(this, "nextDiagram", false, true);

  public NextDiagram1(CompositeEntity container, String name)
    throws NameDuplicationException, IllegalActionException
  {
    super(container, name);
    region.setTypeEquals(BaseType.STRING);
    transitionTable.setTypeEquals(BaseType.OBJECT);
    rowInfo.setTypeEquals(BaseType.GENERAL);
    nextDiagram.setTypeEquals(BaseType.INT); //index to the next diagram.
    rockName.setTypeEquals(BaseType.STRING); //index to the next diagram.

    _attachText("_iconDescription", "<svg>\n"
                + "<rect x=\"-30\" y=\"-20\" "
                + "width=\"60\" height=\"40\" "
                + "style=\"fill:white\"/>\n"
                + "<text x=\"-18\" y=\"-5\" "
                + "style=\"font-size:14\">\n"
                + "Next \n"
                + "</text>\n"
                + "<text x=\"-27\" y=\"13\" "
                + "style=\"font-size:14\">\n"
                + "diagram \n"
                + "</text>\n"
                + "</svg>\n");
  }

  public void fire()
    throws IllegalActionException
  {
    //FIX ME: needs to be updated according to a transition table.
    if (rowInfo.hasToken(0) && region.hasToken(0) && transitionTable.hasToken(0)) {
        StringToken regionToken = (StringToken)region.get(0); //FIX ME!!! TAKE CARE OF EMPTY REGION!!!
        _region = regionToken.stringValue();
        ObjectToken obj1 = (ObjectToken) rowInfo.get(0);
        Rock = (RockSample1) obj1.getValue();
        ObjectToken transFileToken = ((ObjectToken) transitionTable.get(0));
        RockSample1 transRS = (RockSample1) transFileToken.getValue();
        Rock.setAbbrevTable(transRS.getAbbrevTable());
        String transFileStr = transRS.getTransFile();
        File transFile = new File(transFileStr);

        int id = _getNextDiagramId(transFile);
              //ObjectToken obj1 = (ObjectToken) rowInfo.get(0);
      //RockSample1 Rock = (RockSample1) obj1.getValue();
      //float Ol = Rock.get("olivine");
      //float Hbl = Rock.get("hornblende");

      //System.out.println("Ol = " + Ol + " , Hbl = " + Hbl);

        if (id == 0)
        	rockName.broadcast(regionToken);
        else
        	nextDiagram.broadcast(new IntToken(id));
    }

  }

  public void initialize() throws IllegalActionException {
    super.initialize();
    id = 0;
  }

  public boolean postfire() throws IllegalActionException {
  		return true;
  }

  	private boolean _cond(double leftSum, double rightSum, String op) {

  		if (op.equals("lt"))
  			return (leftSum < rightSum);
  		else if (op.equals("lte"))
  			return (leftSum <= rightSum);
  		else if (op.equals("gt"))
  			return (leftSum > rightSum);
	  	else if (op.equals("gte"))
	  		return (leftSum >= rightSum);
  		else if (op.equals("eq"))
  			return (leftSum == rightSum);
	  	else if (op.equals("ne"))
	  		return (leftSum != rightSum);
	  	return false;
   }

  	private int _getNextDiagramId(File transFile) {
  		try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setValidating(false);
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputStream is = new FileInputStream(transFile);
            Document doc = builder.parse(is);

            NodeList nodes = doc.getElementsByTagName("region");
            for (int i = 0; i < nodes.getLength(); i++) {
            	String name = ( (Element) nodes.item(i)).getAttribute("name");
            	if (name.trim().equals(_region.trim())) {
            		NodeList nextDiagrams = ((Element) nodes.item(i)).getElementsByTagName("nextDiagram");
            		for (int j=0; j<nextDiagrams.getLength(); j++) {
            			Element nextDiag = (Element) nextDiagrams.item(j);
            			NodeList conditions = nextDiag.getElementsByTagName("cond");
            			boolean allCondsHold = true;
            			for (int l = 0; l < conditions.getLength(); l++) {
            				Element cond = (Element) conditions.item(l);
                			NodeList leftOps = cond.getElementsByTagName("left");
                			NodeList rightOps = cond.getElementsByTagName("right");
                			NodeList oper = cond.getElementsByTagName("op");
                			double leftSum = 0, rightSum = 0;
                			for (int k=0; k<leftOps.getLength(); k++) {
                				// get all operand names look them up in the
                				//abbreviation table and sum their values.
                				String leftOperand = leftOps.item(k).getFirstChild().getNodeValue();
                				double res = Rock.getCoordinateSum(leftOperand);
                				if (res == -1) // the operand is not in the abbrev table (it should be a value)
                					leftSum += Double.parseDouble(leftOperand);
                				else
                					leftSum += res;
                			}
                			for (int k=0; k<rightOps.getLength(); k++) {
                				// get all operand names look them up in the
                				//abbreviation table and sum their values.
                				String rightOperand = rightOps.item(k).getFirstChild().getNodeValue();
                				double res = Rock.getCoordinateSum(rightOperand);
                				if (res == -1) // the operand is not in the abbrev table (it should be a value)
                					rightSum += Double.parseDouble(rightOperand);
                				else
                					rightSum += res;
                 			}
                			String op = oper.item(0).getFirstChild().getNodeValue();
                			if (!_cond(leftSum, rightSum, op)) {
                				allCondsHold = false;
                				break;
                			}
            			}
            			if (allCondsHold) {
            				String idStr = nextDiag.getAttribute("id");
            				id = Integer.parseInt(idStr);
            				return id;
                		}
            		}
            	}
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }

        return id;

  	}

  	private int id = 0;
  	private RockSample1 Rock = null;
  	private String _region = "";
}
