/* Soot - a J*va Optimization Framework
 * Copyright (C) 1997-1999 Raja Vallee-Rai
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Modified by the Sable Research Group and others 1997-1999.  
 * See the 'credits' file distributed with Soot for the complete list of
 * contributors.  (Soot is distributed at http://www.sable.mcgill.ca/soot)
 */

package soot.jimple;

import soot.*;
import soot.util.*;
import java.util.*;

public class DoubleClassConstant extends Constant
{
    private DoubleClassConstant()
    {
    }

    public static DoubleClassConstant v()
    {
        return new DoubleClassConstant();
    }

    // In this case, equals should be structural equality.
    public boolean equals(Object c)
    {
        return (c instanceof DoubleClassConstant);
    }

    /** Returns a hash code for this ClassConstant object. */
    public int hashCode()
    {
        return toString().hashCode();
    }

    public String toString()
    {
        return "java.lang.Double.TYPE";
    }

    public Type getType()
    {
        return RefType.v("java.lang.Class");
    }

    public void apply(Switch sw)
    {
        ((ConstantSwitch) sw).defaultCase(this);
    }
}
